package uniandes.apo2h.cupiFitCenter.interfaz;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Font;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.ListCellRenderer;

import uniandes.apo2h.cupiFitCenter.mundo.Gimnasio;


public class ListGimnasioRenderer implements ListCellRenderer
{

   public final static Font fuente1 = new Font("Tahoma", Font.BOLD, 14);
	
   public final static Font fuente2 = new Font("Tahoma", Font.PLAIN, 12);
	
	
   public Component getListCellRendererComponent(JList lista, Object value, int indice, boolean isSelected,boolean cellHasFocus) {
		
		if( value instanceof Gimnasio)
		{
			Gimnasio gimnasio = (Gimnasio)value;
			JPanel panel = new JPanel( new BorderLayout());
			
			JLabel lbImagen = new JLabel(new ImageIcon(gimnasio.getCategoria().getImagen()));
			panel.add(lbImagen, BorderLayout.WEST);
			
			JLabel lbNombre = new JLabel( " "+ gimnasio.getNombre());
			lbNombre.setFont(fuente1);
			panel.add(lbNombre, BorderLayout.CENTER);
			
			JLabel lbDatos = new JLabel("  ( Categora: " + gimnasio.getCategoria() + " - Capacidad: " + gimnasio.getCapacidad() + " personas )      ");
			lbDatos.setFont(fuente2);
			panel.add(lbDatos, BorderLayout.SOUTH);
			
			if(isSelected) 
    		{
    			panel.setBackground(new Color(238,238,238)); 
    			lbNombre.setBackground(new Color(238,238,238)); 
    			lbDatos.setBackground(new Color(238,238,238)); 
    			lbImagen.setBackground(new Color(238,238,238)); 
    			panel.setForeground(new Color(80,191,213));
    			lbNombre.setForeground(new Color(80,191,213));
    			lbDatos.setForeground(new Color(80,191,213));
    		}
    		else
    		{
    			panel.setBackground(Color.WHITE);  
    			lbNombre.setBackground(Color.WHITE);
    			lbDatos.setBackground(Color.WHITE);
    			lbImagen.setBackground(Color.WHITE);
    			panel.setForeground(Color.BLACK);
    			lbNombre.setForeground(Color.BLACK);
    			lbDatos.setForeground(Color.BLACK);
    		}
			
			return panel;
		}
		else
		{
			return null;
		}
	}
}
