package uniandes.apo2h.cupiFitCenter.interfaz;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import uniandes.apo2h.cupiFitCenter.mundo.Ciudad;

public class PanelCiudad extends JPanel implements ActionListener
{
	public final static Font fuente1 = new Font("Tahoma", Font.BOLD, 28);
	
	public final static Font fuente2 = new Font("Tahoma", Font.PLAIN, 20);
	
	public final static String COMBO_CIUDAD = "Combo ciudad";
	
	private JLabel lbNombre;
	
	private JComboBox comboCiudades;
	
	private JLabel lbCantidadSedes;
	
	private InterfazCupifitCenter principal;
	
	public PanelCiudad(InterfazCupifitCenter interfaz)
	{
		principal = interfaz;
		
		setLayout(new GridLayout(1,2));
		JPanel panelIzquierda = new JPanel( new BorderLayout());
		setBorder(BorderFactory.createTitledBorder("Ciudades") );
		
		lbNombre = new JLabel("Nombre ciudad:  ");
		lbNombre.setIcon(new ImageIcon(BarraOpciones.RUTA_ICONOS + "ciudades.png"));
		lbNombre.setFont(fuente1);
		lbNombre.setForeground(new Color(80,191,213));
		lbNombre.setHorizontalAlignment(JLabel.RIGHT);
		panelIzquierda.add(lbNombre, BorderLayout.WEST);
		
		comboCiudades = new JComboBox();
		comboCiudades.setRenderer(new ComboBoxRendererCiudad());
		comboCiudades.setActionCommand(COMBO_CIUDAD);
		comboCiudades.addActionListener(this);
		comboCiudades.setFont(fuente2);
		panelIzquierda.add(comboCiudades, BorderLayout.CENTER);
		add(panelIzquierda);
		
		lbCantidadSedes = new JLabel("0 sedes");
		lbCantidadSedes.setFont(fuente2);
		lbCantidadSedes.setForeground(new Color(115,141,58));
		lbCantidadSedes.setHorizontalAlignment(JLabel.RIGHT);
		add(lbCantidadSedes);
	}
	
	public void actualizar(List<Ciudad> ciudades)
	{
		comboCiudades.removeAllItems();
		for(Ciudad c: ciudades)
		{
			comboCiudades.addItem(c);
		}
		comboCiudades.addItem("Agregar ciudad....");
		
	}
	
	public void actualizarCantidad(int cantidad)
	{
		lbCantidadSedes.setText(cantidad + " sedes");

	}
	
	public void cambiarSeleccion(Ciudad ciudad) {
		comboCiudades.setSelectedItem(ciudad);
		
	}
	
	public Ciudad darSeleccionado()
	{
		try {
			return (Ciudad)comboCiudades.getSelectedItem();
		} 
		catch (Exception e) {
			//No debe ocurrir, a menos que haya problemas cargando el archivo
		}
		return null;
	}

	public void actionPerformed(ActionEvent e) 
	{
		if(e.getActionCommand().equals(COMBO_CIUDAD))
		{
			int indice = comboCiudades.getSelectedIndex();
			if(comboCiudades.getItemCount()>1 )
			{
				if(indice == comboCiudades.getItemCount()-1)
				{
					principal.agregarCiudad();
				}
				else
				{
					principal.actualizar(darSeleccionado());
					
				}
			}
		}
		
	}

	
}
