package uniandes.apo2h.cupiFitCenter.interfaz;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;

import uniandes.apo2h.cupiFitCenter.mundo.*;

public class PanelGimnasio extends JPanel implements ActionListener, MouseListener, ListSelectionListener
{
	public final static Font fuente1 = new Font("Tahoma", Font.BOLD, 16);
	
	public final static Font fuente2 = new Font("Tahoma", Font.PLAIN, 14);
	
	public final static String[] TABLA_HORARIOS = new String[]{"Da", "Hora apertura", "Hora cierre"};
	
	public final static String BUSCAR_IMAGEN = "Buscar imagen";
	
	public final static String GUARDAR_CAMBIOS = "Guardar";
	
	public final static String CANCELAR_CAMBIOS = "Canelar";
	
	
	//TODO declara un atributo de tipo JList llamado listaGimnasios para mostrar los gimnasios
	
	private JLabel lbImagen;
	
	private JTextField txtRutaImagen;
	
	private JButton btImagen;
	
	private JPanel panelImagen;
	
	private JPanel panelRutaImagen;
	
	private JLabel lbNombre;
	
	private JTextField txtNombre;
	
	private JLabel lbCapacidad;
	
	private JTextField txtCapacidad;
	
	private JLabel lbDireccion;
	
	private JTextField txtDireccion;
	
	private JLabel lbCategoria;
	
	private JComboBox<Categorias> comboCategoria;
	
	private JLabel lbHorario;
	
	private JTable tablaHorarios;
	
	private JPanel panelBoton;
	
	private JButton btGuardar;
	
	private JButton btCancelar;
	
	private Gimnasio gimnasioActual;
	
	
	public PanelGimnasio()
	{
		setBorder(BorderFactory.createTitledBorder("Gimnasios"));
		setLayout( new BorderLayout());
		
		
		//TODO inicialice el JList de gimnasios y defina el responsable de reaccionar cuando alguien seleccione un elemnto en l
		
		
		listaGimnasios.setCellRenderer(new ListGimnasioRenderer());

		
		JScrollPane scroll = new JScrollPane(listaGimnasios);
		scroll.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		scroll.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		add(scroll, BorderLayout.WEST);
		
		JPanel panelInformacion = new JPanel(new BorderLayout());
		panelInformacion.setBorder(BorderFactory.createEmptyBorder(0, 10, 0, 10));
		panelInformacion.addMouseListener(this);
		
		panelImagen = new JPanel(new BorderLayout());
		
		lbImagen = new JLabel(new ImageIcon("data/images.jpg"));
		lbImagen.setBorder(BorderFactory.createEmptyBorder(0, 0, 10, 0));
		panelImagen.add(lbImagen, BorderLayout.CENTER);
		
		panelRutaImagen = new JPanel(new BorderLayout());
		
		txtRutaImagen = new JTextField("data/images.jpg");
		txtRutaImagen.setEditable(false);
		txtRutaImagen.setFont(fuente2);
		panelRutaImagen.add(txtRutaImagen, BorderLayout.CENTER);
		
		btImagen = new JButton("...");
		btImagen.setActionCommand(BUSCAR_IMAGEN);
		btImagen.addActionListener(this);
		btImagen.setFont(fuente2);
		btImagen.setForeground(Color.WHITE);
		btImagen.setBackground(new Color(80,191,213));
		panelRutaImagen.add(btImagen, BorderLayout.EAST);
		
		panelInformacion.add(panelImagen, BorderLayout.NORTH);
		
		JPanel panelInformacionCentro = new JPanel(new GridLayout(2,1));
		JPanel panelInformacionTexto = new JPanel(new GridLayout(7,2,10,20));
		
		lbNombre = new JLabel("Nombre: ");
		lbNombre.setFont(fuente1);
		lbNombre.setForeground(new Color(80,191,213));
		panelInformacionTexto.add(lbNombre);
		
		txtNombre = new JTextField("El nombre");
		txtNombre.setFont(fuente2);
		txtNombre.setEditable(false);
		panelInformacionTexto.add(txtNombre);
		
		lbCapacidad = new JLabel("Capacidad: ");
		lbCapacidad.setFont(fuente1);
		lbCapacidad.setForeground(new Color(80,191,213));
		panelInformacionTexto.add(lbCapacidad);
		
		txtCapacidad = new JTextField("La capacidad");
		txtCapacidad.setFont(fuente2);
		txtCapacidad.setEditable(false);
		panelInformacionTexto.add(txtCapacidad);
		
		lbDireccion = new JLabel("Direccin: ");
		lbDireccion.setFont(fuente1);
		lbDireccion.setForeground(new Color(80,191,213));
		panelInformacionTexto.add(lbDireccion);
		
		txtDireccion = new JTextField("La direccin");
		txtDireccion.setFont(fuente2);
		txtDireccion.setEditable(false);
		panelInformacionTexto.add(txtDireccion);
		
		
		lbCategoria = new JLabel("Categora: ");
		lbCategoria.setFont(fuente1);
		lbCategoria.setForeground(new Color(80,191,213));
		panelInformacionTexto.add(lbCategoria);
		
		comboCategoria = new JComboBox<Categorias>();
		for(Categorias c: Categorias.values())
		{
			comboCategoria.addItem(c);
		}
		comboCategoria.setFont(fuente2);
		comboCategoria.setEnabled(false);
		panelInformacionTexto.add(comboCategoria);
		
		lbHorario = new JLabel("Horario: ");
		lbHorario.setFont(fuente1);
		lbHorario.setForeground(new Color(80,191,213));
		panelInformacionTexto.add(lbHorario);
		
		panelInformacionCentro.add(panelInformacionTexto);
		
		JPanel panelIformacionInferior = new JPanel(new BorderLayout());
		
		tablaHorarios = new JTable();
		tablaHorarios.setFont(fuente2);
		JScrollPane scroll2 = new JScrollPane(tablaHorarios);
		scroll2.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		scroll2.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		DefaultTableModel modelo = new DefaultTableModel(TABLA_HORARIOS,0);
		String[] fila;
		for (int i = 0; i < 7; i++) 
		{
			fila = new String[] {"Dia"+i,"hin"+"hfin"};
			modelo.addRow(fila);
		}
		tablaHorarios.setModel(modelo);
		tablaHorarios.setEnabled(false);
		panelIformacionInferior.add(scroll2, BorderLayout.CENTER);
		
		panelBoton = new JPanel(new GridLayout(1,2,0 , 20));
		panelBoton.setBorder(BorderFactory.createEmptyBorder(10, 0, 0, 0));
		
		btCancelar = new JButton("Cancelar");
		btCancelar.setActionCommand(CANCELAR_CAMBIOS);
		btCancelar.addActionListener(this);
		btCancelar.setIcon(new ImageIcon("data/iconos/eliminar.png"));
		btCancelar.setFont(fuente2);
		btCancelar.setBackground(new Color(80,191,213));
		btCancelar.setForeground(Color.WHITE);
		
		btGuardar = new JButton("Guardar");
		btGuardar.setActionCommand(GUARDAR_CAMBIOS);
		btGuardar.addActionListener(this);
		btGuardar.setIcon(new ImageIcon("data/iconos/guardar.png"));
		btGuardar.setFont(fuente2);
		btGuardar.setBackground(new Color(80,191,213));
		btGuardar.setForeground(Color.WHITE);
		
		panelIformacionInferior.add(panelBoton, BorderLayout.SOUTH);
		
		panelInformacionCentro.add(panelIformacionInferior);
		panelInformacion.add(panelInformacionCentro, BorderLayout.CENTER);
		
		add(panelInformacion, BorderLayout.CENTER);
		
		gimnasioActual = null;
		
	}
	
	public void activarParaEdicion() 
	{
		txtDireccion.setEditable(true);
		txtCapacidad.setEditable(true);
		comboCategoria.setEnabled(true);
		tablaHorarios.setEnabled(true);
		
		panelImagen.add(panelRutaImagen, BorderLayout.SOUTH);
		panelImagen.repaint();
		panelImagen.revalidate();
		
		panelBoton.add(btCancelar);
		panelBoton.add(btGuardar);
		panelBoton.repaint();
		panelBoton.revalidate();
		
	}
	
	private void desactivarParaEdicion() 
	{
		txtDireccion.setEditable(false);
		txtCapacidad.setEditable(false);
		comboCategoria.setEnabled(false);
		tablaHorarios.setEnabled(false);
		
		
		panelImagen.remove(panelRutaImagen);
		panelImagen.repaint();
		panelImagen.revalidate();
		
		panelBoton.remove(btCancelar);
		panelBoton.remove(btGuardar);
		panelBoton.repaint();
		panelBoton.revalidate();
		actualizarGimnasio(gimnasioActual);
		
	}
	
	public void actualizarLista(List<Gimnasio> gimnasios, int pos)
	{
		Gimnasio[] gs = new Gimnasio[gimnasios.size()];
		listaGimnasios.setListData(gimnasios.toArray(gs));
		if(pos > -1 )
		{
			listaGimnasios.setSelectedIndex(pos);
		}
	}
	
	public void actualizarGimnasio(Gimnasio gimnasio)
	{
		gimnasioActual = gimnasio;
		if(gimnasio == null)
		{
			txtNombre.setText("");
			txtDireccion.setText("");
			txtCapacidad.setText("");
			comboCategoria.setSelectedItem(null);
			lbImagen.setIcon(null);
			DefaultTableModel modelo = new DefaultTableModel(TABLA_HORARIOS,0);
			tablaHorarios.setModel(modelo);
		}
		else
		{
			txtNombre.setText(gimnasio.getNombre());
			txtDireccion.setText(gimnasio.getDireccion());
			txtCapacidad.setText(gimnasio.getCapacidad() + "");
			comboCategoria.setSelectedItem(gimnasio.getCategoria());
			lbImagen.setIcon( new ImageIcon(gimnasio.getImagen()));
			Horario[] hs = gimnasio.getHorarios();
			DefaultTableModel modelo = new DefaultTableModel(TABLA_HORARIOS,0);
			Object[] fila;
			for (int i = 0; i < hs.length; i++) 
			{
				fila = new Object[] {hs[i].getDia(), hs[i].getHoraInicioToString(), hs[i].getHoraFinToString()};
				modelo.addRow(fila);
			}
			tablaHorarios.setModel(modelo);
		}
	}

	public void mouseClicked(MouseEvent e) 
	{
		int cantidad = e.getClickCount();
		if(e.getButton() == MouseEvent.BUTTON1 && cantidad == 2)
		{
			activarParaEdicion();
		}
	}

	

	public void mousePressed(MouseEvent e) 
	{
		// TODO No se implementa
		
	}

	public void mouseReleased(MouseEvent e) 
	{
		// TODO No se implementa
		
	}


	public void mouseEntered(MouseEvent e) 
	{
		// TODO No se implementa
		
	}


	public void mouseExited(MouseEvent e) 
	{
		// TODO No se implementa
		
	}
	
	public void actionPerformed(ActionEvent e)
	{
		String comando = e.getActionCommand();
		if(comando.equals(BUSCAR_IMAGEN))
		{
			JFileChooser jfc = new JFileChooser("data/");
			jfc.setMultiSelectionEnabled(false);
			int opcion = jfc.showOpenDialog(null);
			if(opcion == JFileChooser.APPROVE_OPTION)
			{
				
			}
		}
		else if(comando.equals(CANCELAR_CAMBIOS))
		{
			desactivarParaEdicion();
		}
		else if(comando.equals(GUARDAR_CAMBIOS))
		{
			try 
			{
				String direccion = txtDireccion.getText();
				Categorias categoria = (Categorias) comboCategoria.getSelectedItem();
				String img = txtRutaImagen.getText();
				String cap = txtCapacidad.getText();
				Horario[] hs = darHorarios();
				
				gimnasioActual.setCategoria(categoria);
				gimnasioActual.setDireccion(direccion);
				gimnasioActual.setImagen(img);
				gimnasioActual.setHorarios(hs);
				gimnasioActual.setCapacidad(Integer.parseInt(cap.trim()));
				desactivarParaEdicion();
			} 
			catch (Exception ex) 
			{
				JOptionPane.showMessageDialog(null, "Los horarios ingresados no son vlidos.\n" + ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE, new ImageIcon("data/iconos/error.png"));
			}
		}
	}
	
	private Horario[] darHorarios()throws Exception
	{
		Horario[] hs = new Horario[7];
		
		TableModel modelo = tablaHorarios.getModel();
		for (int i = 0; i < modelo.getRowCount(); i++) 
		{
			String[] hin = ((String)modelo.getValueAt(i, 1)).split(":");
			String[] hfin = ((String)modelo.getValueAt(i, 2)).split(":");
			hs[i] = new Horario((Dias)modelo.getValueAt(i, 0), new int[]{Integer.parseInt(hin[0]), Integer.parseInt(hin[1])}, new int[]{Integer.parseInt(hfin[0]), Integer.parseInt(hfin[1])});
		}
		
		
		return hs;
	}

	public void valueChanged(ListSelectionEvent e) 
	{
		if(e.getFirstIndex()>=0)
		{
			actualizarGimnasio((Gimnasio)listaGimnasios.getSelectedValue());
		}
		
	}
}
