package uniandes.apo2h.cupiFitCenter.mundo;

/**
 * Enumeracin de categorias de los gimnasios del CFC
 * @author alvar-go
 *
 */
public enum Categorias 
{
	PREMIUM("Premium", 100, 500.0, "data/categorias/premium.png"),
	DIAMANTE("Diamante", 90, 500.0, "data/categorias/diamante.png"),
	ESMERALDA("Esmeralda", 80, 500.0, "data/categorias/esmeralda.png"),
	RUBY("Ruby", 70, 500.0, "data/categorias/ruby.png"),
	ZONAL("Zonal", 50, 500.0, "data/categorias/zonal.png");
	
	/**
	 * El nombre de la categoria
	 */
	private String nombre;
	
	/**
	 * El nivel de exclusividad de la categoria
	 */
	private int estrellas;
	
	/**
	 * El precio asociado a la categoria
	 */
	private double precioAnual;
	
	/**
	 * La imagen asociada a la categoria
	 */
	private String imagen;
	
	/**
	 * Crea una caetgoria a a partir de su informacin bsica
	 * @param nombre el nombre de la categoria. nombre != null && nombre != ""
	 * @param estrellas la exclusividad de la categoria. exclusividad > 0 && exclusividad < 100
	 * @param precioAnual el precio asociado a la categoria. precioAnual > 0
	 * @param imagen la imagen de la categoria. 
	 */
	private Categorias(String nombre, int estrellas, double precioAnual, String imagen)
	{
		this.nombre = nombre;
		this.estrellas = estrellas;
		this.precioAnual = precioAnual;
		this.imagen = imagen;
	}
	
	/**
	 * Devuelve el nombre de la categoria
	 * @return nombre
	 */
	public String getNombre() {
		return nombre;
	}


	/**
	 * Devuelve la exclusividad de la cateogira
	 * @return estrellas
	 */
	public int getEstrellas() {
		return estrellas;
	}

	/**
	 * Devuelve el precio asociado a la categoria
	 * @return precioAnual
	 */
	public double getPrecioAnual() {
		return precioAnual;
	}


	/**
	 * Devuelve la iamgen de la categoria
	 * @return imagen
	 */
	public String getImagen() {
		return imagen;
	}


	/**
	 * 
	 * Devuelve la representacin en String de la categoria
	 * @return <nombre>
	 */
	public String toString()
	{
		return nombre;
	}
}
