package uniandes.apo2h.cupiFitCenter.mundo;

import java.util.ArrayList;
import java.util.List;

/**
 * Clase que representa el CupiFitCenter CFC
 * @author alvar-go
 *
 */
public class CupiFitCenter 
{
	/**
	 * Lista de ciudades en que se encuentra el CFC
	 */
	private List<Ciudad> ciudades;
	
	/**
	 * Crea un nuevo CupiFitCenter
	 * post: la lista de ciudades se ha inicializado
	 */
	public CupiFitCenter() {
		ciudades = new ArrayList<Ciudad>();
//		Ciudad b = new Ciudad("Bogot");
//		ciudades.add(b);
//		ciudades.add(new Ciudad("Medellin"));
//		
//		Horario[] hs = new Horario[7];
//		int i = 0;
//		for(Dias d: Dias.values())
//		{
//			hs[i] = new Horario(d, new int[]{7,0}, new int[]{21,0});
//			i++;
//		}
//		try {
//			b.addGimnasio(new Gimnasio("Calle 135", "Autopista # 135", hs, Categorias.PREMIUN, 10, "data/images.jpg"));
//		} catch (Exception e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
	}

	/**
	 * Devuelve la lista de ciudades donde se encuentra el CFC
	 * @return ciudades
	 */
	public List<Ciudad> getCiudades() {
		return ciudades;
	}
	
	/**
	 * Agraga una ciudad al CFC
	 * @param ciudad la nueva ciudad que se desea agregar. ciudad != null
	 * @throws Exception Se lanza en caso que ya exista una ciudad con el nombre de la ciudad que se desea agregar
	 */
	public void addCiudad(Ciudad ciudad) throws Exception
	{
		if(!ciudades.contains(ciudad))
		{
			ciudades.add(ciudad);
		}
		else
		{
			throw new Exception("Ya existe la ciudad: " + ciudad.getNombre());
		}
	}
	
	
}
