package uniandes.apo2h.cupiFitCenter.mundo;

/**
 * Enumeracin de dias de la semana
 * @author alvar-go
 *
 */
public enum Dias 
{
	L("Lunes", "L"),
	M("Martes", "M"),
	I("Mircoles", "I"),
	J("Jueves", "J"),
	V("Viernes", "V"),
	S("Sbado", "S"),
	D("Domingo", "D");
	
	/**
	 * Nombre del da
	 */
	private String nombre;
	
	/**
	 * Letra que representa el da
	 */
	private String letra;
	
	/**
	 * Crea un nuevo da a partir de sus datos bsicos
	 * @param nombre el nombre del da. nombre != null && nombre != ""
	 * @param letra la laetra del da. letra != null && letra != ""
	 */
	private Dias(String nombre, String letra)
	{
		this.nombre = nombre;
		this.letra = letra;
	}

	/**
	 * Devuelve el nombre del da
	 * @return nombre
	 */
	public String getNombre() {
		return nombre;
	}

	/**
	 * Devuelve la letra del da
	 * @return letra
	 */
	public String getLetra() {
		return letra;
	}
	
	/**
	 * Devuelve la representacin en String del da
	 * @return <nombre>
	 */ 
	public String toString()
	{
		return nombre;
	}
	
	
}
