package uniandes.apo2h.utiles;

import java.util.Comparator;
import java.util.List;

/**
 * Clase genrica para buscar elementos
 * @author alvar-go
 *
 * @param <V> tipo de elementos que busca
 */
public class Buscador<V> {

	/**
	 * Busca el elemento mayor dentro de una lista de acuerdo a un criterio
	 * @param elementos la lsita de elementos donde se desea buscar. elementos != null
	 * @param comparador el comarador asociado al criterio de busqueda. comaprador != null
	 * @return el elemento mayor o null en caso que la lista no tenga elementos
	 */
	public V buscarMayor( List<V> elementos, Comparator<V> comparador)
	{
		//TODO Complete segn la documentacin
		V buscado = null;
		if( elementos.size() > 0 )
		{
			buscado = elementos.get(0);
			for (int i = 1; i < elementos.size(); i++) 
			{
				V actual = elementos.get(i);
				if(comparador.compare(actual, buscado) > 0){
						buscado = actual;
				}
			}
		}
		
		return buscado;
	}
	
	/**
	 * Busca el elemento menor dentro de una lista de acuerdo a un criterio
	 * @param elementos la lsita de elementos donde se desea buscar. elementos != null
	 * @param comparador el comarador asociado al criterio de busqueda. comaprador != null
	 * @return el elemento menor o null en caso que la lista no tenga elementos
	 */
	public V buscarMenor( List<V> elementos, Comparator<V> comparador)
	{
		//TODO Complete segn la documentacin
		V buscado = null;
		if( elementos.size() > 0 )
		{
			buscado = elementos.get(0);
			for (int i = 1; i < elementos.size(); i++) 
			{
				V actual = elementos.get(i);
				if(comparador.compare(actual, buscado) < 0){
						buscado = actual;
				}
			}
		}
		
		return buscado;
	}
	
}
