package uniandes.apo2h.utiles;

import java.util.Comparator;
import java.util.List;

/**
 * Clsae que permite ordenar elementos en una lisat
 * @author alvar-go
 *
 * @param <V> el tipo de elementos que se desea ordenar
 */
public class Ordenador<V> 
{

	/**
	 * Ordena los elementos de la lista que llega por parmetro
	 * @param algoritmo el algoritmo que se desea usar para ordenar. algoritmo != null
	 * @param ascendente la direccin del ordenamiento. true si es ascedente o false si es descendente
	 * @param comparador  el criterio de comparacin que se usar. comaprador != null
	 * @param elementos la lista de elementos que se desea ordenar. elementos != null
	 */
	public void ordenar(Ordenamientos algoritmo, boolean ascendente, Comparator<V> comparador, List<V> elementos)
	{
		if(algoritmo.equals(Ordenamientos.BURBUJA))
		{
			ordenarBurbuja(elementos, ascendente, comparador);
		}
		else if(algoritmo.equals(Ordenamientos.SELECCION))
		{
			ordenarSeleccion(elementos, ascendente, comparador);
		}
		else if(algoritmo.equals(Ordenamientos.INSERCION))
		{
			ordenarInsercion(elementos, ascendente, comparador);
		}
		else if(algoritmo.equals(Ordenamientos.BURBUJA_BIDERECCIONAL))
		{
			ordenarShaker(elementos, ascendente, comparador);
		}
		else if(algoritmo.equals(Ordenamientos.GNOME))
		{
			ordenarGnome(elementos, ascendente, comparador);
		}
	}
	
	/**
	 * Ordena la lista usando el algoritmo de inscercin
	 * post: la lista se encuentra ordenada
	 * @param lista la lista que se desea ordenar. lsita != null
	 * @param ascendnte indica si se debe ordenar de mamenra ascendente, de lo contrario se ordenar de manera descendente
	 * @param comparador comparador de elementos tipo T que se usar para ordenar la lista, define el criterio de orden. comparador != null.
	 */
	private void ordenarInsercion(List<V> lista,boolean ascendnte, Comparator<V> comparador) {
		//TODO Complete segn la documentacin
		
	}

	/**
	 * Ordena la lista usando el algoritmo de seleccin
	 * post: la lista se encuentra ordenada
	 * @param lista la lista que se desea ordenar. lsita != null
	 * @param ascendnte indica si se debe ordenar de mamenra ascendente, de lo contrario se ordenar de manera descendente
	 * @param comparador comparador de elementos tipo T que se usar para ordenar la lista, define el criterio de orden. comparador != null.
	 */
	private void ordenarSeleccion(List<V> lista,boolean ascendnte, Comparator<V> comparador) {
		//TODO Complete segn la documentacin
		
		
	}

	/**
	 * Ordena la lista usando el algoritmo de burbuja
	 * post: la lista se encuentra ordenada
	 * @param lista la lista que se desea ordenar. lsita != null
	 * @param ascendnte indica si se debe ordenar de mamenra ascendente, de lo contrario se ordenar de manera descendente
	 * @param comparador comparador de elementos tipo T que se usar para ordenar la lista, define el criterio de orden. comparador != null.
	 */
	private void ordenarBurbuja(List<V> lista,boolean ascendnte, Comparator<V> comparador) {	
		//TODO Complete segn la documentacin
		
	}
	
	/**
	 * Ordena la lista usando el algoritmo de shake (burbuja bidireccional)
	 * post: la lista se encuentra ordenada
	 * @param lista la lista que se desea ordenar. lsita != null
	 * @param ascendnte indica si se debe ordenar de mamenra ascendente, de lo contrario se ordenar de manera descendente
	 * @param comparador comparador de elementos tipo T que se usar para ordenar la lista, define el criterio de orden. comparador != null.
	 */
	private void ordenarShaker(List<V> lista,boolean ascendnte, Comparator<V> comparador)
	{
		//TODO Complete segn la documentacin
		
	}
	
	
	/**
	 * Ordena la lista usando el algoritmo de Gnome
	 * post: la lista se encuentra ordenada
	 * @param lista la lista que se desea ordenar. lsita != null
	 * @param ascendnte indica si se debe ordenar de mamenra ascendente, de lo contrario se ordenar de manera descendente
	 * @param comparador comparador de elementos tipo T que se usar para ordenar la lista, define el criterio de orden. comparador != null.
	 */
	private void ordenarGnome(List<V> lista,boolean ascendnte, Comparator<V> comparador) {
		//TODO Complete segn la documentacin
		
		
		
	}
}
