package uniandes.apo2h.mundo.test;

import junit.framework.TestCase;
import uniandes.apo2h.cupiFitCenter.mundo.Categorias;
import uniandes.apo2h.cupiFitCenter.mundo.ComparadorGimansioCapacidad;
import uniandes.apo2h.cupiFitCenter.mundo.Dias;
import uniandes.apo2h.cupiFitCenter.mundo.Gimnasio;
import uniandes.apo2h.cupiFitCenter.mundo.Horario;

/**
 * Clase que prueba el comparador de gimnasios por capacidad
 * @author alvar-go
 *
 */
public class ComparadorGimnasioCapacidadTest extends TestCase{
	
	/**
	 * Comaprador a evaluar
	 */
	private ComparadorGimansioCapacidad comparador;
	
	/**
	 * Gimnasio 1 para probar
	 */
	private Gimnasio g1;
	
	/**
	 * Gimnasio 2 para probar
	 */
	private Gimnasio g2;
	
	/**
	 * Crea el escenario de prueba
	 */
	public void setUp(){
		comparador = new ComparadorGimansioCapacidad();
		Horario[] hs = new Horario[Gimnasio.CANTIDAD_HORARIOS];
		int i = 0;
		for(Dias d: Dias.values())
		{
			hs[i] = new Horario(d, new int[]{7,0}, new int[]{21,0});
			i++;
		}
		g1 = new Gimnasio("Calle 135", "Autopista # 135", hs, Categorias.PREMIUM, 20, "data/images.jpg");
		g2 = new Gimnasio("Calle 135", "Autopista # 135", hs, Categorias.PREMIUM, 10, "data/images.jpg");
	}
	
	/**
     * Prueba 1: Se encarga de verificar el mtodo compare de la clase.<br>
     * <b> Mtodos a probar: </b> <br>
     * compare<br>
     * <b> Casos de prueba:</b><br>
     * 1. Se  compar correctamente un gimnasio mayor con uno menor.<br>
     * 2. Se  compar correctamente un gimnasio menor con uno mayor.<br>
     * 3. Se  compar correctamente dos gimnasios igualesr.<br>
     */
	public void testCompare()
	{
		assertEquals("Se comparan incorrectamente mayor con menor", 1, comparador.compare(g1, g2));
		assertEquals("Se comparan incorrectamente menor con mayor", -1, comparador.compare(g2, g1));
		assertEquals("Se comparan incorrectamente iguales", 0, comparador.compare(g1, g1));
	}

}
