package uniandes.apo2h.mundo.test;

import junit.framework.TestCase;
import uniandes.apo2h.cupiFitCenter.mundo.Dias;
import uniandes.apo2h.cupiFitCenter.mundo.Horario;

/**
 * Clase que prueba la clase horario
 * @author alvar-go
 *
 */
public class HorarioTest extends TestCase {

	/**
	 * Clase a probar
	 */
	private Horario horario;
	
	
	/**
	 * Crea el escenario de pruebas
	 */
	public void setUp(){
		horario  = new Horario(Dias.L, new int[]{8,0}, new int[]{20,30});
	}
	

	/**
     * Prueba 1: Se encarga de verificar el mtodo getDia de la clase.<br>
     * <b> Mtodos a probar: </b> <br>
     * getDia<br>
     * <b> Casos de prueba:</b><br>
     * 1. Se asign correctamente el da al horario.<br>
     */
	public void testGetDia() 
	{
		assertEquals("El da se asigno incorrectamente", Dias.L, horario.getDia());
	}


	/**
     * Prueba 2: Se encarga de verificar el mtodo getHoraInicio de la clase.<br>
     * <b> Mtodos a probar: </b> <br>
     * getHoraInicio<br>
     * <b> Casos de prueba:</b><br>
     * 1. Se asign correctamente la hora inicio al horario.<br>
     */
	public void testGetHoraInicio() 
	{
		int[] hora = horario.getHoraInicio();
		assertEquals("La hora inicio asigno incorrectamente", 8, hora[0]);
		assertEquals("El minuto de inicio asigno incorrectamente", 0, hora[1]);
	}


	/**
     * Prueba 3: Se encarga de verificar el mtodo getHoraFin de la clase.<br>
     * <b> Mtodos a probar: </b> <br>
     * getHoraFin<br>
     * <b> Casos de prueba:</b><br>
     * 1. Se asign correctamente la hora fin al horario.<br>
     */
	public void testGetHoraFin() 
	{
		int[] hora = horario.getHoraFin();
		assertEquals("La hora fin asigno incorrectamente", 20, hora[0]);
		assertEquals("El minuto de fin asigno incorrectamente", 30, hora[1]);
	}
	

	/**
     * Prueba 4: Se encarga de verificar el mtodo getHoraInicioToString de la clase.<br>
     * <b> Mtodos a probar: </b> <br>
     * getHoraInicioToString<br>
     * <b> Casos de prueba:</b><br>
     * 1. Se asign correctamente la hora inicio al horario.<br>
     */
	public void testGetHoraInicioToString() 
	{
		assertEquals("La hora inicio asigno incorrectamente", "8:00", horario.getHoraInicioToString());
	}


	/**
     * Prueba 5: Se encarga de verificar el mtodo getHoraFinToString de la clase.<br>
     * <b> Mtodos a probar: </b> <br>
     * getHoraFinToString<br>
     * <b> Casos de prueba:</b><br>
     * 1. Se asign correctamente la hora fin al horario.<br>
     */
	public void testGetHoraFinToString() 
	{
		assertEquals("La hora fin asigno incorrectamente", "21:30", horario.getHoraFinToString());
	}


	/**
     * Prueba 6: Se encarga de verificar el mtodo setDia de la clase.<br>
     * <b> Mtodos a probar: </b> <br>
     * setDia<br>
     * getDia<br>
     * <b> Casos de prueba:</b><br>
     * 1. Se asign correctamente el da al horario.<br>
     */
	public void testSetDiaTest() 
	{
		horario.setDia(Dias.M);
		assertEquals("El da se asigno incorrectamente", Dias.M, horario.getDia());
	}


	/**
     * Prueba 7: Se encarga de verificar el mtodo setHoraInicio de la clase.<br>
     * <b> Mtodos a probar: </b> <br>
     * setHoraInicio<br>
     * getHoraInicioToString<br>
     * <b> Casos de prueba:</b><br>
     * 1. Se asign correctamente la hora inicio al horario.<br>
     */
	public void testSetHoraInicio(int[] horaInicio) 
	{
		horario.setHoraInicio(new int[]{9,30});
		assertEquals("La hora inicio asigno incorrectamente", "9:30", horario.getHoraInicioToString());
	}

	/**
     * Prueba 8: Se encarga de verificar el mtodo setHoraFin de la clase.<br>
     * <b> Mtodos a probar: </b> <br>
     * setHoraFin<br>
     * getHoraFinToString<br>
     * <b> Casos de prueba:</b><br>
     * 1. Se asign correctamente la hora fin al horario.<br>
     */
	public void setHoraFin(int[] horaFin) 
	{
		horario.setHoraFin(new int[]{19,0});
		assertEquals("La hora fin asigno incorrectamente", "19:00", horario.getHoraFinToString());
	}
		
	
}
